//-----------------------------------------------------
// 2006 Tri-Digital Software, Inc. All rights reserved.
//-----------------------------------------------------

//
// Application Logic
//
var LocalTestPath = 'C:/Convergence2007';

var DEBUG = true;

var currentSubView = 'Audio';
var currentPlayingIndex = 0;
var currentClip = null;
var currentEntry = null;

var PrevClip = null;
var PrevSlide = null;

var SmallPlayerTop = 113;     //113
var SmallPlayerLeft = 31;     //73
var SmallPlayerWidth = 320;
var SmallPlayerHeight = 240;

var LargePlayerWidth = 640;   //800
var LargePlayerHeight = 496;  //578
var LargePlayerTop = 100;     //101
var LargePlayerLeft = 371;    //414

var SliderOpen = -0;          //43
var SliderClosed = 327;       //364


var PlayListHeight = 240;  //339

var TotalRunningTime = 0;

var PlaySpeed = 'Normal';

var IsPlayerChangeEvent = false;
var DisableTimer = false;
var IsDemoLoaded = false;
var IsExternalState = false;



var isPlaylistOpen = true;
var isDemoRunning = true;
var slidesLocation = "Slides/";
var FileLocation = "";


var Pres = new Presentation();

var slide, mc;
var Level1 = "   ";
var Level2 = "      ";
var currentSlide = "";

var currentPlayState = 'Stopped';

Playlist = new Array();

Level1 = "";
Level2 = "";

function Blank()
{
   
}

/*
   Presentation Class
*/
function Presentation()
{
   this.CurrentPlayingIndex = 0;
   
   //Actual movie clips that make up this presentation.
   this.media = new Array();
   
   this.Save = function()
   {
      try
      {
         //create the Main script 
         buffer = '';
         buffer += "var MainPresentation = new Presentation();\n\n";
         
         //Call save on the Chapters
         for(ClipCount = 0; ClipCount < this.media.length; ClipCount++)
         {  
            buffer += this.media[ClipCount].Save('MainPresentation');
         } 
                  
         return buffer;          
      }
      catch(ex)
      {
         return buffer;
      }
   }
   
   //Get a count of the actual clips that make up this presentation
   this.Count = function()
   {
      if(this.media == null || this.media == 'undefined')
      {
         return 0;
      }
      
      return this.media.length;
   }
   
   //Get Clip By Index
   this.GetClip = function(index)
   {
      //Check if there is a valid Clip array
      if(this.media == null || this.media == 'undefined' || this.media.length == 0)
      {
         throw new Error(35,'Error Retrieving Clips');
      }
      
      if(this.media.length > index || this.media.length < index)
      {
         //throw new Error(35,'No Clips Found');
      }
      
      return this.media[index];
   }
      
   //Get Clip By Index
   this.GetClipByName = function(clipName)
   {
      //Check if there is a valid Clip array
      if(this.media == null || this.media == 'undefined' || this.media.length == 0)
      {
         throw new Error(35,'Error Retrieving Clips');
      }
      
      //Check for the Media 
      for(i = 0; i < this.media.length; i++)
      {
         if(this.media[i].GetPlayerName() == clipName)
            return this.media[i];
      }
      
      
      return null;
   }
      
   
   //Find the Movie clip for a given Timecode
   this.GetClipByTimecode = function(timeCode)
   {
      //Check if there is a valid Clip array
      if(this.media == null || this.media == 'undefined')
      {
         return null;
      }
      
      //Check for the Media 
      for(i = 0; i < this.media.length; i++)
      {
         if(this.media[i].CheckNode(timeCode))
            return this.media[i];
      }
      
      return null;
   }
   
   //Add a Media Clip to the array
   this.AddClip = function(movie)
   {
      this.media[this.media.length] = movie;
   }     
   
}

/*
   Movie Clip Class
   The clip class hold information about the actual movie clip.
   Including what mode to play back in.
*/
function MovieClip()
{
   this.Index = 0;
   this.ID = '';
   this.timeIn = "";
   this.timeOut = "";
   this.length = 0;
   this.Name = "";
   this.Notes = "";
   this.URL = "";
   this.EntryIndex = -1;
   this.ShowInPlaylist = 'false';
      
   this.Transcription = new Transcription();
   this.Slides = new SlideShowManager();
   
   this.Mode = 'Audio';
   
   /*
      Saves the Chapter Node
   */
   this.Save = function(objParent)
   {
      var name = '';
      var txt = '';
      
      try
      {    
         name = "Clip" + this.Number;
            
         txt += "var " + this.ID + " = new MovieClip();\n";
         txt += this.ID + ".ID = '" + this.ID + "';\n";
         txt += this.ID + ".Name = '" + this.Name + "';\n";
         txt += this.ID + ".Notes = '" + this.Notes + "';\n";
         txt += this.ID + ".URL = '" + this.URL + "';\n";   
         txt += this.ID + ".Mode = '" + this.Mode + "';\n";  
         txt += this.ID + ".ShowInPlaylist = '" + this.ShowInPlaylist + "';\n";        
         
         txt += this.ID + ".timeIn = " + (this.timeIn == "" ? "''" : this.timeIn) + ";\n";
         txt += this.ID + ".timeOut = " + (this.timeOut==''?"''":this.timeOut) + ";\n";
         
         txt += this.ID + ".length = '" + this.length + "';\n";
         txt += "\n";
                  
         /*
            Save the Child object (Slides and/or Transcripts)
            Starting with the Slides
         */    
         txt += this.Slides.Save(this.ID);
         
         //Save this clip to the parent object
         txt += objParent + ".AddClip(" + this.ID + ");\n\n";    
         
         return txt;
      }
      catch(ex)
      {
         return txt;
      }
      
   }
   
   this.Count = function()
   {  
      return this.Slides.Count();
   }
      
   this.AddSlide = function(slide)
   {
      this.Slides.AddSlide(slide);
   }
   
   this.GetSlide = function(timecode)
   {
      return this.Slides.GetSlide(timecode);
   }
   
   this.GetSlideByIndex = function(index)
   {
      return this.Slides.GetSlideByIndex(index);
   }  
   
   
   this.CheckNode = function(timeCode)
   {      
      var time = timeCode;
      var In = ConvertTimeCodeToSeconds(this.timeIn);
      var Out = ConvertTimeCodeToSeconds(this.timeOut);
      
      //alert(timeCode + '\n' + In + '\n' + Out);
      
		if(time >= In && time <= Out)
		{
		   //This slide does happen at this time
			return true;
		}
		
		return false;
   }
   
   this.GetPlayerName = function()
   {
      var pname;
      
      locbreak = this.URL.lastIndexOf('/');
      
      pname = this.URL.substring(locbreak + 1, this.URL.length);
      pname = pname.substring(0, pname.lastIndexOf('.')); 
      
      return pname;
   } 
   
   MovieClip.prototype.toString = function()
   {     
      return "Mode: " + this.Mode + "\n" + "Slide Count: " + this.Slides.Count();
   }  
}



/*
   Transcription Class
*/
function Transcription()
{  
   //The Array of transcripts - this is initially empty.
   this.transcripts = new Array();
   
   //Count property is the count of node in the transcript array.
   this.Count = function()
   {   
      //if the transcripts is null (should never occur) then just return 0;
      if(this.transcripts == null || this.transcripts == 'undefined')
         return 0;
               
      return this.transcripts.length;
   } 
   
   //Given a time code this will return the Transcript for that time, if there is one
   this.GetTranscript = function(timeCode)
   {
      //if the transcripts is null (should never occur) then just return null since there is no transcript.
      if(this.transcripts == null || this.transcripts == 'undefined')
         return null;    
               
      //Check for Transcript
      for(i = 0; i < this.transcripts.length; i++)
      {
         if(this.transcripts[i].CheckTranscript(timeCode))
            return this.transcripts[i];
      }
      
      return null;
   }
   
   //Add a Transcript to the array
   this.AddTranscript = function(trans)
   {
      this.transcripts[this.transcripts.length] = trans;
   }   
}


/*
   Transcript Class
*/
function Transcript()
{
   this.timeIn = "";
   this.timeOut = "";
   this.text = "";
   
   this.Save = function(objParent)
   {
      var name = "";
      var txt = "";
      
      try
      {
         txt += "\n";
         
         for(TCount = 0; TCount < this.transcripts.length; TCount++)
         {            
            txt += this.transcripts[TCount].Save();
            txt += objParent + ".AddTranscriptNode(" + this.transcripts[TCount].ID + ");\n\n";
         }
         
         return txt;
      }
      catch(ex)
      {
         return '';
      }
   }
   
   this.SetTranscript = function(In, Out, Text)
   {
      this.timeIn = In;
      this.timeOut = Out;
      this.text = Text;
   }
   
   this.CheckTranscript = function(timeCode)
   {      
      var time = timeCode;
      var In = ConvertTimeCodeToSeconds(this.timeIn);
      var Out = ConvertTimeCodeToSeconds(this.timeOut);
      
		if(time >= In && time <= Out)
		{
		   //This transcript does happen at this time
			return true;
		}
		
		return false;
   } 
   
   Transcript.prototype.toString = function()
   {     
      return "Text: " + this.text + "\n" + "In: " + this.timeIn + "\n" + "Out: " + this.timeOut;
   }  
}


/*
   Slide Container Class
*/
function SlideShowManager()
{  
   this.ID = '';
   
   //The Array of Slides - this is initially empty.
   this.slides = new Array();
   
   this.Save = function(objParent)
   {
      txt = '//Saving Slides\n';
      
      try
      {
         for(SlideCnt = 0; SlideCnt < this.slides.length; SlideCnt++)
         {
            txt += this.slides[SlideCnt].Save();
            txt += objParent + ".AddSlide(" + this.slides[SlideCnt].ID + ");\n\n";
         }
         
         return txt;
      }
      catch(ex)
      {
         return txt;
      }
   }
   
   //Count property is the count of node in the Slides array.
   this.Count = function()
   {   
      //if the slides array is null (should never occur) then just return 0;
      if(this.slides == null || this.slides == 'undefined')
         return 0;
               
      return this.slides.length;
   } 
   
   //Given a time code this will return a Slide for that time, if there is one
   this.GetSlide = function(timeCode)
   {
      //if the slides array is null (should never occur) then just return null since there is no transcript.
      if(this.slides == null || this.slides == 'undefined')
         return null;    
               
      //Check for a Slide
      for(i = 0; i < this.slides.length; i++)
      {
         if(this.slides[i].CheckNode(timeCode))
            return this.slides[i];
      }
      
      return null;
   }
   
   this.GetSlideByIndex = function(index)
   {
      //if the slides array is null (should never occur) then just return null since there is no transcript.
      if(this.slides == null || this.slides == 'undefined')
         return null;   
         
      if(this.slides.length < index || index < 0) return null;
      
      return this.slides[index];
   }
   
   //Add a Slide to the array
   this.AddSlide = function(slide)
   {
      this.slides[this.slides.length] = slide;
   }   
}


/*
   Slide Class
*/
function Slide()
{
   this.ID = "";
   this.Index = -1;
   this.timeIn = "";
   this.timeOut = "";
   this.imageURL = "";
   this.Name = "";
   
   this.Save = function(objParent)
   {
      txt = '';
      
      try
      {
         txt = '';
         txt += "var " + this.ID + " = new Slide();\n";
         txt += this.ID + ".Name = '" + this.Name + "'; \n";
         txt += this.ID + ".timeIn = '" + this.timeIn + "'; \n";
         txt += this.ID + ".timeOut = '" + this.timeOut + "'; \n";
         txt += this.ID + ".imageURL = '" + this.imageURL + "'; \n\n";
         
         
         return txt;
      }
      catch(ex)
      {
         return txt;
      }
   }
   
   this.SetNode = function(id, In, Out, url)
   {
      this.timeIn = In;
      this.timeOut = Out;
      this.imageURL = url;
      this.ID = id;
   }
   
   this.CheckNode = function(timeCode)
   {      
      var time = timeCode;
      var In = ConvertTimeCodeToSeconds(this.timeIn);
      var Out = ConvertTimeCodeToSeconds(this.timeOut);
      
		if(time >= In && time <= Out)
		{
		   //This slide does happen at this time
			return true;
		}
		
		return false;
   } 
   
   Slide.prototype.toString = function()
   {     
      return "Url: " + this.imageURL + "\n" + "In: " + this.timeIn + "\n" + "Out: " + this.timeOut;
   }  
}


/*
   Helper class for organizing the playlist items
*/
function PlayListEntry(view, slide, url, timein, timeout, mode, isChild)
{
   this.ID = '';
   this.Index = 0;
   this.ViewableName = view;
   this.Mode = 'Audio';
   this.Slide = slide;
   this.URL = url;
   this.TimeIn = timein;
   this.TimeOut = timeout; 
   this.Mode = mode;
   this.ClipIndex = -1;
   this.IsChild = isChild == null | isChild == '' | isChild == 'undefined' ? false : isChild;
}




/*
   Utility Functions
*/
function ConvertTimeCodeToSeconds(sTime) 
{
	var nCount;
	var arrTime = sTime.split(":");
	var TimeInSeconds = 0;
	
	for(nCount = 0; nCount < arrTime.length; nCount++)
		TimeInSeconds += arrTime[arrTime.length - (nCount + 1)] * (Math.pow(60, nCount));
	
	return TimeInSeconds;
		
}


function ConvertSecondsToTimeCode(time)
{
   var Delta;
   var Hours = 0;
   var Minutes = 0;
   var Seconds= 0;
   
   var sHour = "00";
   var sMin = "00";
   var sSec = "00";
   
   try
   {
      //Get the Hours
      if(time > 3600)
      {
         Delta = Math.floor(time/3600);
         Hours = Delta;
         time = time - (Hours * 3600);
         
         sHour = Hours < 10 ? "0" + Hours : Hours;         
      }
      
      //Get the Minutes
      if(time > 60)
      {
         Delta = Math.floor(time/60);
         Minutes = Delta;
         time = time - (Minutes * 60);
         
         sMin = Minutes < 10 ? "0" + Minutes : Minutes;
      }
      
      if(time > 0)
      {
         Seconds = Math.floor(time);
         
         sSec = Seconds < 10 ? "0" + Seconds : Seconds;
      }
      
      return sHour + ":" + sMin + ":" + sSec;
   }
   catch(ex)
   {
      DebugMsg(ex.message);
   }
}

var pl;
function CreatePlaylist()
{  
      
   try
   {
      plArray = player.playlistCollection.getByName('PL');
      
      for(i = 0; i < plArray.count; i++)
      {
         player.playlistCollection.remove(plArray.item(i));
      }
      
      if(FileLocation == '' && !IsStreaming)
      {
         throw new Error( 'Invalid File Location');
      }
      
      IsPlayerChangeEvent = true;
      
      pl = player.playlistCollection.newPlaylist('PL');
          
      
      for(ClipCount = 0; ClipCount < MainPresentation.Count(); ClipCount++)
      {
         mc = MainPresentation.GetClip(ClipCount);
         
         if(IsStreaming)
            url = mc.URL;
         else
            url = FileLocation + mc.URL;
         
         pl.appendItem(player.newMedia(url));
      }
      
      if(pl.length == 0 || pl == null)
      {
         DebugMsg('No entries in PL');
         return false;
      }
      
      //player.currentPlaylist = pl;
      
      return true;
   }
   catch(ex)
   {
      DebugMsg('Error creating the Playlist: ' + ex.message);
      return false;
   }
   finally
   {
      IsPlayerChangeEvent = false;
   }
}



function GetCDDrive()
{
   var CDDriveLetter;
   
   try
   {
      FileLocation = "";
      
      //return LocalTestPath;
       
      for(i = 0; i < player.CdromCollection.count; i++)
      {      
         CDDriveLetter = player.CdromCollection.item(i).driveSpecifier;
         
         //DebugMsg(CDDriveLetter + FileLocation + '/Demo1/Content/Audio.wmv');
         
         //Check if this is the drive.
         MediaItem = player.newMedia(CDDriveLetter + FileLocation + currentClip.URL);
         
         //DebugMsg(CDDriveLetter + FileLocation + '/' +  MediaItem.Duration); return null;         
         
         if(MediaItem.Duration > 0)
         {
            FileLocation = CDDriveLetter + FileLocation;
            return CDDriveLetter;
         }
      }
   
      //use the file system if no CD found
      return FileLocation = LocalTestPath;
      
   }
   catch(ex)
   {
      DebugMsg('Error while Getting CD: ' + ex.message);
   }
   
}


/*
   Handle Players Onload Event
*/
function InternalInit()
{  
   try
   {
      ResetPlayer();
      
      svVisual.visible = false;
      PPTArea.visible = true;
      video.visible = false;  
      //SmallVideo.visible = false;   
     
      player.settings.setMode('loop',false);
      player.settings.setMode('shuffle',false);
      player.controls.stop();
      player.URL = '';
      
      SmallVideoImageArea.backgroundImage = '../../Art/prerollImage.bmp';
      //SmallVideoImageArea.visible = false;
      //SmallVideoContainer.visible = false;
      
      
            
      if(!isDemoRunning)
      {     
         if(player.openState < 13) return;
       
         svVisual.visible = true;
         DebugMsg(player.currentMedia.name);
         //playlist.setColumnResizeMode(0,'Stretches');
      }  
      else
      {
         //Call the Main Startup function
         //playlist.visible = false;
         LoadPresentation();
         lstPlayList.selectedItem = 0; 
         
         
         //Set the CurrentClip to 0
         currentClip = MainPresentation.GetClip(0);  
         currentEntry = Playlist[0]; 
         
         //DebugMsg('Index: ' + currentEntry.EntryIndex);return;         
                 
         if(IsStreaming || GetCDDrive() != null) 
         {
            //DebugMsg(FileLocation); return; 
            Launch = true;
            if(!CreatePlaylist())
            {
               return;
            }
            
            currentPlayingIndex = 0;
            MainPresentation.CurrentPlayingIndex = currentPlayingIndex;
            
            //player.controls.play();     
            //InternalHandleVideoStart();
            
            switch(currentEntry.Mode.toLowerCase())
            {
               case "audio":
                  SwapToVideo('audio');
                  //TextMsg("Now Playing: " + currentClip.Name);
                  break;
                  
               case "demo":
                  SwapToVideo('demo');  
                  //TextMsg("Now Playing: " + currentClip.Name);      
                  break;
                  
               case "video":
                  SwapToVideo('video');
                  //TextMsg("Now Playing: " + currentClip.Name);
                  break;
                  
               default:
                  TextMsg("No Swapping");
            }
            
            //Set the focus to the Play button (pause button) which doesnt work
            view.focusObjectID = 'stop';
            
            IsPlayerChangeEvent = true;
            
            //player.controls.Play();
            player.settings.autoStart = false;
            player.currentPlaylist = pl;
            player.controls.Play();
         }
         else
         {
            TextMsg('Unable to locate CD Drive.');
            return;
         }
         /**/
      }   
   }  
   catch(ex)
   {
      DebugMsg(ex.message);
      view.close();
   }
   finally
   {      
      IsPlayerChangeEvent = true;
   }
}


function LoadPlayList()
{
   var item;
   
   try
   { 
      lstPlayList.visible = true;
      lstPlayList.deleteAll();
          
      entry = null;
      vname = "";
      slideFileName = "";
      url = "";
      timein = "";
      timeout = "";
      mode = 'Audio'; 
      showInPL = 'false';     
      
      MediaCount = MainPresentation.Count();
      ItemCount = 0;
      
      for(ClipCount = 0; ClipCount < MediaCount; ClipCount++)
      {
         mc = MainPresentation.GetClip(ClipCount);
         
         TotalRunningTime += ConvertTimeCodeToSeconds(mc.length);
         
         vname = mc.Name;
         url = mc.URL;
         timein = "00:00";
         timeout = "";
         mode = mc.Mode;
         showInPL = mc.ShowInPlaylist;
         
         
         entry = new PlayListEntry(vname, slideFileName, url, timein, timeout, mode, true)
         mc.Index = ClipCount;
         mc.EntryIndex = Playlist.length;
                  
         
         entry.Index = Playlist.length;
         entry.ClipIndex = ClipCount;
         
         
         //Dont show the top nodes unless they are configured to
         if(mc.Count() == 0)
         {
            Playlist[Playlist.length] = entry;
            lstPlayList.appendItem(entry.ViewableName);
            
            slideModifier = 0;
         }
         else
         {
            slideModifier = 1;
         }
         
         if(mc.ShowInPlaylist.toLowerCase() == 'true' && mc.Count() != 0)
         {
            Playlist[Playlist.length] = entry;
            lstPlayList.appendItem(entry.ViewableName); 
            slideModifier = -1;
         }
         
         //Get the Slides for this Clip
         SlideCount = mc.Count();
         ItemCount++;
         
         for(SlideCounter = 0; SlideCounter < SlideCount; SlideCounter++)
         {
            slide = mc.GetSlideByIndex(SlideCounter);
            
            
            vname = Level1 + slide.Name; 
            slideFileName = slide.imageURL;
            timein = slide.timeIn;
            timeout = slide.timeOut;
            
            entry = new PlayListEntry(vname, slideFileName, url, timein, timeout, mode, false)
            //slide.Index = entry.Index = Playlist.length;
            slide.Index = entry.Index = SlideCounter + slideModifier;
            entry.ClipIndex = ClipCount;
            Playlist[Playlist.length] = entry;
            lstPlayList.appendItem(entry.ViewableName);
            ItemCount++;
         }
      }
      
      //Change the Height of the Mock Playlist
      /*
      PlayListHeight = 240;
      var playListBuffer = 12.5; //15 - 12.5
      lstPlayList.height = (playListBuffer * (ItemCount+1));
      
      if(lstPlayList.height > PlayListHeight) lstPlayList.height = PlayListHeight;
      */
      ResizePlaylist();
      
      
      SetClock('00:00:00 | ' + ConvertSecondsToTimeCode(TotalRunningTime));
      
   }
   catch(ex)
   {
   
   }
}

function ResizePlaylist()
{ 
   lstPlayList.fontSize = 10;  
   //Line height is roughly 16 for FontSize 10
   PlayListHeight = PlaylistContainer.height - (252);
   var playListBuffer = 15; 
   
   ICnt = lstPlayList.itemCount;
   
   lstPlayList.height = (ICnt * playListBuffer);
   lstPlayList.height = PlayListHeight;
   
   if(lstPlayList.height > PlayListHeight) lstPlayList.height = PlayListHeight;
}

function SetPlayList()
{
   view.focusObjectID = 'lstPlayList';
   view.close();
}

function ReleasePlayList()
{
   view.focusObjectID = 'btnMinClose';
}

function Test()
{  
   lstPlayList.visible = false;
   lstPlayList.visible = true;
   needRefresh = false;
}

var HighlightCount = 0;
var needRefresh = false;
function ConfigurePlaylistItem()
{
   var currentSlide;
   
   try
   {  
      if(DisableTimer) return;
   
      if(pauseHighlight)
      {
         if(HighlightCount++ == 10)
         {
            pauseHighlight = false;
            HighlightCount = 0;
         }
         
         return;
      }      
      
      //IF the playlist has focus dont have it autoscroll back to the selected item
      if(view.focusObjectID == 'lstPlayList') 
      {   
         //Check to see if the Playlist would scroll
         if(lstPlayList.firstVisibleItem > lstPlayList.selectedItem)
            return;
      }
      
      if(currentClip.Count() == 0)
      {
         lstPlayList.selectedItem = currentClip.EntryIndex ;
         return;   
      }
      
      currentSlide = currentClip.GetSlide(player.controls.currentPosition);      
           
      for(i = 0; i < lstPlayList.itemCount; i++)
      {
         if(i < currentClip.EntryIndex) continue;
         if(currentSlide.Name == lstPlayList.getItem(i))
         {
            lstPlayList.selectedItem = i;
            break;
         }
      }
   }
   catch(ex)
   {
      DebugMsg(ex.message);
   }   
}

function InternalHandleVideoEnd()
{
   try
   {
      ResetPlayer();
   }
   catch(ex)
   {
      DebugMsg(ex.message);
   }
}



/*
   Handle Player State Change Event
*/
function InternalHandleStateChange()
{  
   try
   {
      var state = player.playState; 
      var HasSlides = false;
            
      if(state == 3)
      {
         Launch = false;
      }
      
      
      if(state == 9)
      {  
         if(Launch && (currentClip.GetPlayerName() ==  player.currentMedia.Name) )
         {
            return;
         }
         
         if(true)
         {
            if(player.playState !=9) return;
            
            //Launch = true;
            
            //Reset the Player state
            pauseHighlight = false;
            ResetPlayer();
                        
            //Save the current slide
            HasSlides = currentClip.Count() > 0 ? true : false;            
            if(HasSlides)
            {
               currentSlide = currentClip.GetSlideByIndex(currentClip.Count()-1);
            }
            
            //Get the Next clip if there is one.
            if(currentPlayingIndex == MainPresentation.Count() - 1) return;
            
            //currentPlayingIndex++;
            currentPlayingIndex = currentPlayingIndex + 1;
            
            MainPresentation.CurrentPlayingIndex = currentPlayingIndex;            
            currentClip = MainPresentation.GetClip(currentPlayingIndex);
            currentEntry = Playlist[currentClip.EntryIndex]; 
                        
            switch(currentEntry.Mode.toLowerCase())
            {
               case "audio":
                  SwapToVideo('audio');
                  //TextMsg("Now Playing: " + currentClip.Name);
                  break;
                  
               case "demo":
                  SwapToVideo('demo');  
                  //TextMsg("Now Playing: " + currentClip.Name);      
                  break;
                  
               case "video":
                  SwapToVideo('video');
                  //TextMsg("Now Playing: " + currentClip.Name);
                  break;
                  
               default:
                  TextMsg("No Swapping");
            }
            
             //Check for Slides    
            /* */    
            if(currentEntry.Mode != 'Video' && currentPlayingIndex != 0)
            {  
               PrevClip = MainPresentation.GetClip(currentPlayingIndex -1);
               
               if(PrevClip.Count() > 0)
               {
                  PrevSlide = PrevClip.GetSlideByIndex(PrevClip.Count()-1);
                  SmallVideoImageArea.resizeBackgroundImage = true;
                  SmallVideoImageArea.backgroundImage = 'Slides/' + PrevSlide.imageURL;
               }
            }
                                 
            return;
         }
      }
      
   }
   catch(ex)
   {
      DebugMsg(ex.message);
   }
}

/*
   Handles the Previous Button Click
*/
function HandlePrevious()
{
   try
   {  
      if(player.playState != 3) return;
      
      if(IsExternalState) return;
      
      //Get the item clicked on in the playlist
      index = lstPlayList.selectedItem;
      
      if(index==0) return;
      
      
      
      //Get the actual media item
      currentEntry = selItem = Playlist[index-1];
      
      //Launch = true;
      
      //If the item has chnnged and the player is running stop the player
      if(currentEntry.ClipIndex != currentClip.Index)
      {
         Launch = true;
         
         if(player.playState == 3)
            player.controls.stop();      
         
         currentClip = MainPresentation.GetClip(currentEntry.ClipIndex);
         currentPlayingIndex = currentClip.Index;         
         MainPresentation.CurrentPlayingIndex = currentPlayingIndex;
         
         ProcessPlaylistEvent(currentEntry,true);
         player.controls.currentPosition = (ConvertTimeCodeToSeconds(currentEntry.TimeIn)+.1);  
         
         Launch = true;
      }
                  
      
      player.controls.currentPosition = (ConvertTimeCodeToSeconds(currentEntry.TimeIn)+.1);
      return;
   }
   catch(ex)
   {
      DebugMsg(ex.message);
   }
}

/*
   Handles the Next Button Click
*/
function HandleNext()
{
   try
   {      
      if(player.playState != 3) return;
      
      if(IsExternalState) return;
      
      //Get the item clicked on in the playlist
      index = lstPlayList.selectedItem;
      
      if(index+1 >= lstPlayList.itemCount) return;
      
      
      
      //Get the actual media item
      currentEntry = selItem = Playlist[index+1];
      
      //Launch = true;
      
      //If the item has chnnged and the player is running stop the player
      if(currentEntry.ClipIndex != currentClip.Index)
      {
         Launch = true;
         
         if(player.playState == 3)
            player.controls.stop();      
         
         currentClip = MainPresentation.GetClip(currentEntry.ClipIndex);
         currentPlayingIndex = currentClip.Index;         
         MainPresentation.CurrentPlayingIndex = currentPlayingIndex;
         
         ProcessPlaylistEvent(currentEntry,true);
         player.controls.currentPosition = (ConvertTimeCodeToSeconds(currentEntry.TimeIn)+.1);  
         
         Launch = true;
      }
                  
      
      player.controls.currentPosition = (ConvertTimeCodeToSeconds(currentEntry.TimeIn)+.1);
      return;
   }
   catch(ex)
   {
      DebugMsg(ex.message);
   }
}

/*
   Handle Video Start Event
   This occurs when the user clicks the Play button
*/
var cnt = 0;
var Flag = true;
function InternalHandleVideoStart()
{
   try
   {
      g_SetPlayPauseFocus=true;      
      if(player.playState == 2)
      {
         player.controls.play();
         return;
      }
      
      if(player.playState == 3) return;
      
      //return;
      
      
      Launch = true;      
      
      //Get the item clicked on in the playlist
      index = lstPlayList.selectedItem;
      
      if(index > 1) view.close();
      
      //Get the actual media item
      currentEntry = Playlist[index];
      
      //DebugMsg('Index: ' + currentEntry.ClipIndex + "::" + currentClip.Index ); return;
      
      //If the item has chnnged and the player is running stop the player
      if(currentEntry.ClipIndex != currentClip.Index)
      {   
         currentClip = MainPresentation.GetClip(currentEntry.ClipIndex);
         currentPlayingIndex = currentEntry.ClipIndex;         
         MainPresentation.CurrentPlayingIndex = currentPlayingIndex;
         
       
         player.controls.currentPosition = (ConvertTimeCodeToSeconds(currentEntry.TimeIn)+.1);         
         //DebugMsg('Changing CurrentClip: ' + index); return;
      }
             
      //ResetPlayer();    
      
      //Set the current media item to the item at plIndex in the actual playlist.
      ProcessPlaylistEvent(currentEntry,true); Launch = true;
      player.controls.currentPosition = (ConvertTimeCodeToSeconds(currentEntry.TimeIn)+.1);  
      
      switch(currentEntry.Mode.toLowerCase())
      {
         case "audio":
            SwapToVideo('audio');
            //TextMsg("Now Playing: " + currentClip.Name);
            break;
            
         case "demo":
            SwapToVideo('demo');  
            //TextMsg("Now Playing: " + currentClip.Name);      
            break;
            
         case "video":
            SwapToVideo('video');
            //TextMsg("Now Playing: " + currentClip.Name);
            break;
            
         default:
            TextMsg("No Swapping");
      }
      
   }
   catch(ex)
   {      
      DebugMsg(ex.message);
   }
}

function InternalHandleMouseEvent(item)
{
   var index;
   var plIndex;
   var name;
   
   try
   {  
      if(IsExternalState) return;
      
      //Get the item clicked on in the playlist
      index = item.selectedItem;
      
      //Get the actual media item
      currentEntry = selItem = Playlist[index];
      
      //Launch = true;
      
      //If the item has changed and the player is running stop the player
      if(currentEntry.ClipIndex != currentClip.Index)
      {
         Launch = true;
         
         if(player.playState == 3)
            player.controls.stop();      
         
         currentClip = MainPresentation.GetClip(currentEntry.ClipIndex);
         currentPlayingIndex = currentClip.Index;         
         MainPresentation.CurrentPlayingIndex = currentPlayingIndex;
         
         //DebugMsg('URL: ' + currentEntry.Name);return;
      }
                  
      if(player.playState == 3)
      {
         player.controls.currentPosition = (ConvertTimeCodeToSeconds(currentEntry.TimeIn)+.1);
         return;
      }
      
      //ResetPlayer();    
      
      //Set the current media item to the item at plIndex in the actual playlist.
      ProcessPlaylistEvent(currentEntry,true);
      player.controls.currentPosition = (ConvertTimeCodeToSeconds(currentEntry.TimeIn)+.1);  
      
      Launch = true;
   }
   catch(ex)
   {
      DebugMsg(ex.message);
   }
}

function ProcessPlaylistEvent(selItem, playerStop)
{
   var m;
   
   try
   {  
      IsPlayerChangeEvent = true;
      
      //ResetPlayer();
      name = currentEntry.ViewableName; 
      
      Launch  = true;
            
      m = player.currentPlaylist.item(currentClip.Index);
      player.controls.playItem(m);  
            
      SetPlaySpeed();
      
      if(currentSubView.toLowerCase() != selItem.Mode.toLowerCase())
      {      
         switch(selItem.Mode.toLowerCase())
         {
            case "audio":
               SwapToVideo('audio');
               break;
               
            case "demo":
               SwapToVideo('demo');     
               break;
               
            case "video":
               SwapToVideo('video');
               break;
         }      
      }
      
      if(currentEntry.Mode.toLowerCase() == 'demo')
      {
         //video.visible = true;
         //SmallVideo.visible = false;         
      }
                  
      currentPlayState = 'playing';
      
      if(currentEntry.Mode.toLowerCase() != 'demo')
         SwapPPT();
      
      TextMsg("Now Playing: " + currentClip.Name);
      
      pauseHighlight = false;
      Launch = false;
      
   }
   catch(ex)
   {
      DebugMsg(ex.message + ' in ProcessPlaylistEvent');
   }
   finally
   {
      IsPlayerChangeEvent = true;
   }
}

pauseHighlight = false;
function HandlePlayListChange(doNothing, isKeyPress)
{
   try
   {  
      if(doNothing) 
      {
         return;
      }
      
      if(IsExternalState)
      {
         view.focusObjectID = 'bgMinClose';            
         return;
      }
      
      //stop the highlighting
      pauseHighlight  = true;
      
      if(isKeyPress)
      {  
         if(event.keyCode != 13)
         {  
            return;
         }
      }
      
      
      
      InternalHandleMouseEvent(lstPlayList); 
      pauseHighlight = false;
   }
   catch(ex)
   {
      DebugMsg(ex);
   }
}

function HandleFastPlayClick(isKey)
{
   var btnPre = '../../Art/fastPlaybtn';
   var btnUp = 'Up.bmp';
   var btnDown = 'Down.bmp';
   var btnHover = 'Hover.bmp';
   
   var btn = FastPlayButton;
   
   try
   {
      if(isKey)
      {
         if(event.keyCode != 13)
            return;
      }
      
      if(PlaySpeed == 'X2')
      {
         //player.settings.rate = 1.0;
         PlaySpeed = 'Normal';  
         
         //Change the PlaySpeed Button to the Normal Speed 
         btn.image      = btnPre + 'X1' + btnUp;
         btn.downImage  = btnPre + 'X1' + btnDown;
         btn.hoverImage = btnPre + 'X1' + btnHover;
              
         
      }
      else
      {  
         if(player.settings.IsAvailable('Rate'))
         {
            //player.settings.rate = 2.0;
            PlaySpeed = 'X2';
            
            //Change the PlaySpeed Button to the X2
            btn.image      = btnPre + 'X2' + btnUp;
            btn.downImage  = btnPre + 'X2' + btnDown;
            btn.hoverImage = btnPre + 'X2' + btnHover;
            
         }         
      }
      
      SetPlaySpeed();
   }
   catch(ex)
   {
   
   }
}



function DoSize()
{  

   switch(currentSubView)
   {
      case 'Audio':
         PPTArea.backgroundImage = "";
         PPTArea.resizeBackgroundImage = false;
         
         view.size( 'bottomright' ); 
         
         PPTArea.backgroundImage = "";
         PPTArea.resizeBackgroundImage = true;
         SwapPPT();
         break;
         
      case 'Demo':
         var CurrentSlideImage = SmallVideoImageArea.backgroundImage;
         
         SmallVideoImageArea.backgroundImage = "";
         SmallVideoImageArea.resizeBackgroundImage = false;
         
         view.size( 'bottomright' ); 
         
         SmallVideoImageArea.resizeBackgroundImage = true;
         SmallVideoImageArea.backgroundImage = CurrentSlideImage;
         
         SmallVideoImageArea.visible = true;

         break;
         
      case 'Video':
         PPTArea.backgroundImage = "";
         PPTArea.resizeBackgroundImage = false;
         
         view.size( 'bottomright' ); 
         
         PPTArea.backgroundImage = "";
         PPTArea.resizeBackgroundImage = true;
         SwapPPT(); 
         break;
   }
   
   
}

function CheckForPlayingFile(fileName)
{
   try
   {
      return MainPresentation.GetClipByName(fileName);  
   }
   catch(ex)
   {
      DebugMsg(ex.message);
   }
}

function SwapPPT()
{
   var file;
   var fileName = "Slide";
   var fileExt =  ".gif";  
   
   var currentRunningTime = 0;
   var localCurrentClip = null;

   
   try
   {
      if(currentClip == null) return;
      
      //DebugMsg(currentClip.URL);return;
      
      if(currentPlayingIndex > 0)
      {
         for(i = 0; i < MainPresentation.Count(); i++)
         {
            if(i == currentPlayingIndex) break;
            clip = MainPresentation.GetClip(i);            
            currentRunningTime += ConvertTimeCodeToSeconds(clip.length);
         }
      }
      
      
      currentRunningTime += player.controls.currentPosition;
      
      //If an external file was loaded then handle it
      if(!IsStreaming)
      {
         currentName = player.currentMedia.Name;
         if(currentName != currentClip.GetPlayerName())
         {
            //Check For Vista Bug
            localCurrentClip = CheckForPlayingFile(player.currentMedia.Name);
            if(localCurrentClip == null)
            {
               TextMsg('Press Ctrl+B to Resume Presentation');
               //DebugMsg('CurrentName: ' + currentClip.GetPlayerName());
               return;
            }
            else
            {
               
               currentClip = localCurrentClip;
               
               /*Reset the interface to the mode type*/
               if(localCurrentClip.Mode.toLowerCase())
               {      
                  switch(localCurrentClip.Mode.toLowerCase())
                  {
                     case "audio":
                        SwapToVideo('audio');
                        break;
                        
                     case "demo":
                        SwapToVideo('demo');     
                        break;
                        
                     case "video":
                        SwapToVideo('video');
                        break;
                  }      
               }               
            }
         }
      }
      else
      {
         currentName = player.currentMedia.sourceURL;
         if(currentName != currentClip.URL)
         {
            if(CheckForPlayingFile(currentName) == null)
            {
               TextMsg('Press Ctrl+B to Resume Presentation');
               //DebugMsg('CurrentName: ' + player.currentMedia.sourceURL);
               return;
            }
         } 
         else
         {
            
            currentClip = localCurrentClip;
            
            /*Reset the interface to the mode type*/
            if(localCurrentClip.Mode.toLowerCase())
            {      
               switch(localCurrentClip.Mode.toLowerCase())
               {
                  case "audio":
                     SwapToVideo('audio');
                     break;
                     
                  case "demo":
                     SwapToVideo('demo');     
                     break;
                     
                  case "video":
                     SwapToVideo('video');
                     break;
               }      
            }
            
         }
      }
      

      //Change the Clock
      SetClock(ConvertSecondsToTimeCode(currentRunningTime) + ' | '  + ConvertSecondsToTimeCode(TotalRunningTime));
      
      if(currentClip.Mode.toLowerCase() == 'demo')
      {
         ConfigurePlaylistItem();
         TextMsg("Now Playing: " + currentClip.Name);
         
         if(currentEntry.Mode != 'Video' && currentPlayingIndex != 0)
         {  
            PrevClip = MainPresentation.GetClip(currentPlayingIndex -1);
            
            if(PrevClip.Count() > 0)
            {
               PrevSlide = PrevClip.GetSlideByIndex(PrevClip.Count()-1);
               SmallVideoImageArea.resizeBackgroundImage = true;
               SmallVideoImageArea.backgroundImage = 'Slides/' + PrevSlide.imageURL;
            }
         }
            
         return;
      }
      
            
      /**/
      //Check the current Clip for slides
      if(currentClip.Count() < 1)
      {
         //Hide the slide area
         PPTArea.visible = false;      
         return;         
      }
      
      //Get the Slide
      slide = currentClip.GetSlide(player.controls.currentPosition);
      
      if(slide == null)
      {
         //Hide the slide area
         PPTArea.visible = false;
         return; 
      }
      
      file = slide.imageURL;
     
      //lstPlayList.selectedItem = slide.Index;
      TextMsg("Now Playing: " + slide.Name);
      currentSlide = file;
      
      //Set the Image
      PPTArea.backgroundImage = "Slides/" + currentSlide;
      PPTArea.visible = true;
      
      ConfigurePlaylistItem();
      
   }
   catch(ex)
   {
      DebugMsg(ex.message);
   }
}


/*
  Test function that swaps video screens 
*/
var currentVideoHeight = 480, currentVideoWidth = 640;
function SwapToVideo(newView)
{  
   
   //SmallVideo.visible = false;
   video.visible = false;
   
   switch(newView.toLowerCase())
   {
       case 'video':
         //Change to Video (small media player)
         SmallVideoImageArea.visible = false;         
         ShowVisualizations(false);
         svVisual.visible = false;
         video.visible = false;
         PPTArea.visible = true;
         
         currentVideoHeight = video.Height;
         currentVideoWidth = video.Width;
         
         /**/
         video.top      = SmallPlayerTop;
         video.Left     = SmallPlayerLeft;
         video.Height   = SmallPlayerHeight;
         video.Width    = SmallPlayerWidth;
         
         video.horizontalAlignment = "left";
         video.verticalAlignment = "top";
         video.visible = true;
         //SmallVideo.visible = true;
                 
         currentSubView = 'Video';
         break;
         
      case 'demo': 
         //DebugMsg('Calling Demo');
         SmallVideoImageArea.visible = true;        
         ShowVisualizations(false);
         svVisual.visible = false;
         PPTArea.visible = false; 
         video.visible = false;
         //SmallVideo.visible = false;
         
         /**/
         video.top      = LargePlayerTop;
         video.Left     = LargePlayerLeft;
         video.Height   = VideoPanel.Height - 16;
         video.Width    = VideoPanel.Width;
         
         video.horizontalAlignment = "stretch";
         video.verticalAlignment = "stretch";
         video.visible = true;
         
         
         currentSubView = 'Demo';
         break;
         
       case 'audio':
         //DebugMsg('Calling Audio');
         SmallVideoImageArea.visible = true;
         ShowVisualizations(false);
         svVisual.visible = false;         
         PPTArea.visible = true;
         
         video.visible = false;
         
         currentSubView = 'Audio';
         break;
         
      
   } 
}

function ResetPlayer()
{
   
   SmallVideoImageArea.resizeBackgroundImage = false;
   SmallVideoImageArea.backgroundImage = '../../Art/prerollImage.bmp';
   
   
   ClearDebug();   
}

function SetPlaySpeed()
{ 
   try
   {  
      if(!player.settings.IsAvailable('Rate'))
         return;
         
      switch(PlaySpeed)
      {
         case 'X2':
            player.settings.rate = 1.5;
            break;
            
         case 'Normal':
            player.settings.rate = 1.0;
            break;
      }
   }
   catch(ex)
   {
      DebugMsg('SetPlaySpeed: ' + ex.message);
   }
}

function HandlePlayerError(obj)
{
   DebugMsg('Player Error::' + player.error.item(0).errorDescription);
   //view.close();
}

/**/
function TextMsg(txt)
{  
   DebugText.value = txt;
   DebugText.visible = true;
}

/**/
function DebugMsg(txt)
{
   if(DEBUG)
   {
      //txt = "res://wmploc.dll/RT_STRING/#1536";
     
      DebugText.value = txt;
      DebugText.visible = true;
   }
}

function ClearDebug()
{
   DebugText.value = "";
   DebugText.visible = false;
}

function SetClock(txt)
{
   ClockArea.value = txt;
   ClockArea.visible = true;
}
